//=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
//                    This source created by dlg2src
//                    Target: C++/TCLib
//=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
#define UNICODE
#define _UNICODE
#include <windows.h>
#define   x64
#include "TCLib\stdio.h"
#include "TCLib\string.h"
#include "TCLib\stdlib.h"
#include "TCLib\memory.h"
#include "TCLib\malloc.h"
#include "TCLib\math.h"
#include "TCLib\tchar.h"
#include "TCLib\Strings.cpp"
#include <commctrl.h>
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"gdi32.lib")
#pragma comment(lib,"advapi32.lib")
//==============================================================================
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);
//==============================================================================
void Center_Win (HWND hwnd)
{
    RECT     WndRect = {0};
    long     x = {0};
    long     y = {0};
    GetWindowRect(hwnd, &WndRect);
    x = ( GetSystemMetrics( SM_CXSCREEN) - ( WndRect.right - WndRect.left)) / 2;
    y = ( GetSystemMetrics( SM_CYSCREEN) - ( WndRect.bottom - WndRect.top + GetSystemMetrics( SM_CYCAPTION))) / 2;
    SetWindowPos(hwnd, NULL, x, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
}
//==============================================================================
HFONT Create_Font (const _TCHAR* szFaceName, long lPointSize)
{
    LOGFONT  tlf = {0};
    HDC      hdc = {0};
    hdc = GetDC( HWND_DESKTOP);
    tlf.lfHeight = - MulDiv( lPointSize, GetDeviceCaps( hdc, LOGPIXELSY), 72);
    tlf.lfWidth = 0;
    tlf.lfEscapement = 0;
    tlf.lfOrientation = 0;
    tlf.lfWeight = 0;
    tlf.lfItalic = 0;
    tlf.lfUnderline = 0;
    tlf.lfStrikeOut = 0;
    tlf.lfCharSet = ANSI_CHARSET;
    tlf.lfOutPrecision = OUT_TT_PRECIS;
    tlf.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    tlf.lfQuality = DEFAULT_QUALITY;
    tlf.lfPitchAndFamily = FF_DONTCARE;
    _tcscpy(tlf.lfFaceName, szFaceName);
    ReleaseDC(HWND_DESKTOP, hdc);
    return (HFONT)CreateFontIndirect( &tlf);
}
//==============================================================================
void SetClientSize (HWND hwnd, long nWidth, int nHeight)
{
    RECT     rc = {0};
    RECT     rcTemp = {0};
    SetRect( &rc, 0, 0, nWidth, nHeight);
    HANDLE   hMenu = GetMenu(hwnd);
    DWORD    dwStyle = GetWindowLongPtr(hwnd, GWL_STYLE);
    AdjustWindowRectEx( &rc, dwStyle, (hMenu != NULL), GetWindowLongPtr(hwnd, GWL_EXSTYLE));
    if(hMenu != NULL )
    {
        rcTemp = rc;
        rcTemp.bottom = 0x7FFF;
        SendMessage(hwnd, (UINT)WM_NCCALCSIZE, (WPARAM)0, (LPARAM)&rcTemp);
        rc.bottom +=   rcTemp.top;
    }
    if((dwStyle & WS_HSCROLL) == WS_HSCROLL )
    {
        rc.bottom = rc.bottom + GetSystemMetrics( SM_CYHSCROLL);
    }
    if((dwStyle & WS_VSCROLL) == WS_VSCROLL )
    {
        rc.right = rc.right + GetSystemMetrics( SM_CXVSCROLL);
    }
    long     cx = rc.right - rc.left;
    long     cy = rc.bottom - rc.top;
    SetWindowPos(hwnd, NULL, 0, 0, cx, cy, SWP_NOZORDER | SWP_NOMOVE | SWP_NOACTIVATE);
}
//==============================================================================
#define IDD_DLG1  1000
#define IDC_INDEX1  1001
#define IDC_INDEX2  1002
#define IDC_COMPANY1  1003
#define IDC_COMPANY2  1004
#define IDC_FIRST  1005
#define IDC_FIRSTNAME  1006
#define IDC_LAST  1007
#define IDC_LASTNAME  1008
#define IDC_ADDRESS1  1009
#define IDC_ADDRESS2  1010
#define IDC_CITY1  1011
#define IDC_CITY2  1012
#define IDC_COUNTY  1034
#define IDC_COUNTY2  1013
#define IDC_STATE1  1014
#define IDC_STATE2  1015
#define IDC_ZIP1  1016
#define IDC_ZIP2  1017
#define IDC_PHONE11  1018
#define IDC_PHONE12  1019
#define IDC_PHONE21  1020
#define IDC_PHONE22  1021
#define IDC_EMAIL1  1022
#define IDC_EMAIL2  1023
#define IDC_URL1  1024
#define IDC_URL2  1025
#define IDC_PRIOR  1026
#define IDC_NEXT  1027
#define IDC_FIND  1028
#define IDC_ADD  1029
#define IDC_UPDATE  1030
#define IDC_DELETE  1031
#define IDC_PRINT  1032
#define IDC_CLOSE  1033
//==============================================================================
int WINAPI _tWinMain (HINSTANCE  hInst, HINSTANCE  hPrev, LPWSTR  CmdLine, int CmdShow)
{
    HWND     hWin = {0};
    HWND     hCtl = {0};
    WNDCLASSEX  wcx = {0};
    MSG      uMsg = {0};
    HFONT    hFont = {0};
    _TCHAR     szClassName[] = _T("SdkWindow");
    INITCOMMONCONTROLSEX  icc = {0};
    icc.dwSize = sizeof( icc);
    icc.dwICC = ICC_NATIVEFNTCTL_CLASS | ICC_COOL_CLASSES | ICC_BAR_CLASSES | ICC_TAB_CLASSES | ICC_USEREX_CLASSES | ICC_WIN95_CLASSES | ICC_STANDARD_CLASSES | ICC_ANIMATE_CLASS | ICC_DATE_CLASSES | ICC_HOTKEY_CLASS | ICC_INTERNET_CLASSES | ICC_LISTVIEW_CLASSES | ICC_PAGESCROLLER_CLASS | ICC_PROGRESS_CLASS | ICC_TREEVIEW_CLASSES | ICC_UPDOWN_CLASS;
    InitCommonControlsEx( &icc);
    wcx.cbSize = sizeof( wcx);
    wcx.style = CS_HREDRAW | CS_VREDRAW;
    wcx.lpfnWndProc = WndProc;
    wcx.cbClsExtra = 0;
    wcx.cbWndExtra = 0;
    wcx.hInstance = hInst;
    wcx.hIcon = LoadIcon( NULL, IDI_APPLICATION);
    wcx.hCursor = LoadCursor( NULL, IDC_ARROW);
    wcx.hbrBackground = ( HBRUSH)( COLOR_BTNFACE + 1);
    wcx.lpszMenuName = 0;
    wcx.lpszClassName = szClassName;
    wcx.hIconSm = LoadIcon( NULL, IDI_APPLICATION);
    if(!RegisterClassEx( &wcx))
    {
        MessageBox (GetActiveWindow(), (_T("RegisterClassEx Failed")), _T(""), 0 );
         return 0;
    }
    hFont = Create_Font(L"Tahoma",10);
    hWin = CreateWindowEx(0,szClassName,L"Address Book",0x10CA0800,0,0,0,0,0,0,hInst,NULL);
    SetClientSize(hWin,445,490);
    hCtl = CreateWindowEx(0,L"Static",L"Record No.",0x50000000,275,10,89,16,hWin,(HMENU)IDC_INDEX1,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Static",L"0  /  0",0x50001201,361,8,70,20,hWin,(HMENU)IDC_INDEX2,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Static",L"Company",0x50000000,9,48,105,16,hWin,(HMENU)IDC_COMPANY1,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0x00000200,L"Edit",L"",0x50010000,119,44,263,24,hWin,(HMENU)IDC_COMPANY2,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Static",L"First Name",0x50000000,9,76,105,16,hWin,(HMENU)IDC_FIRST,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0x00000200,L"Edit",L"",0x50010000,119,72,263,24,hWin,(HMENU)IDC_FIRSTNAME,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Static",L"Last Name",0x50000000,9,104,105,16,hWin,(HMENU)IDC_LAST,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0x00000200,L"Edit",L"",0x50010000,119,100,263,24,hWin,(HMENU)IDC_LASTNAME,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Static",L"Address",0x50000000,9,132,105,16,hWin,(HMENU)IDC_ADDRESS1,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0x00000200,L"Edit",L"",0x50010000,119,128,263,24,hWin,(HMENU)IDC_ADDRESS2,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Static",L"City",0x50000000,9,160,105,16,hWin,(HMENU)IDC_CITY1,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0x00000200,L"Edit",L"",0x50010000,119,156,263,24,hWin,(HMENU)IDC_CITY2,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Static",L"County",0x50000000,9,188,105,16,hWin,(HMENU)IDC_COUNTY,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0x00000200,L"Edit",L"",0x50010000,119,184,263,24,hWin,(HMENU)IDC_COUNTY2,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Static",L"State",0x50000000,9,216,105,16,hWin,(HMENU)IDC_STATE1,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0x00000200,L"Edit",L"",0x50010000,119,212,51,24,hWin,(HMENU)IDC_STATE2,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Static",L"Zip",0x50000000,9,244,105,16,hWin,(HMENU)IDC_ZIP1,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0x00000200,L"Edit",L"",0x50010000,119,240,100,24,hWin,(HMENU)IDC_ZIP2,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Static",L"Phone #1",0x50000000,9,272,105,16,hWin,(HMENU)IDC_PHONE11,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0x00000200,L"Edit",L"",0x50010000,119,268,121,24,hWin,(HMENU)IDC_PHONE12,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Static",L"Phone #2",0x50000000,9,300,105,16,hWin,(HMENU)IDC_PHONE21,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0x00000200,L"Edit",L"",0x50010000,119,296,121,24,hWin,(HMENU)IDC_PHONE22,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Static",L"Email",0x50000000,9,328,105,16,hWin,(HMENU)IDC_EMAIL1,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0x00000200,L"Edit",L"",0x50010000,119,324,263,24,hWin,(HMENU)IDC_EMAIL2,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Static",L"WWW",0x50000000,9,356,105,16,hWin,(HMENU)IDC_URL1,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0x00000200,L"Edit",L"",0x50010000,119,352,263,24,hWin,(HMENU)IDC_URL2,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Button",L"<< Prior",0x50010000,46,406,70,28,hWin,(HMENU)IDC_PRIOR,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Button",L"Next >>",0x50010000,140,406,70,28,hWin,(HMENU)IDC_NEXT,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Button",L"Find",0x50010000,235,406,70,28,hWin,(HMENU)IDC_FIND,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Button",L"Add",0x50010000,331,406,70,28,hWin,(HMENU)IDC_ADD,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Button",L"Update",0x50010000,46,442,70,28,hWin,(HMENU)IDC_UPDATE,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Button",L"Delete",0x50010000,140,442,70,28,hWin,(HMENU)IDC_DELETE,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Button",L"Print",0x50010000,235,442,70,28,hWin,(HMENU)IDC_PRINT,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    hCtl = CreateWindowEx(0,L"Button",L"Close",0x50010000,331,442,70,28,hWin,(HMENU)IDC_CLOSE,hInst,NULL);
    SendMessage(hCtl,(UINT)WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
    Center_Win(hWin);
    ShowWindow(hWin,SW_SHOW);
    while(GetMessage( &uMsg, NULL, 0, 0))
    {
        if(IsDialogMessage(hWin, &uMsg))
        {
            continue;
        }
        TranslateMessage( &uMsg);
        DispatchMessage( &uMsg);
    }
    return uMsg.wParam;
}
//==============================================================================
LRESULT CALLBACK WndProc (HWND hWnd, UINT Msg, WPARAM  wParam, LPARAM  lParam)
{
    switch(Msg)
    {
    case WM_COMMAND:
        if(LOWORD(wParam) == IDCANCEL && HIWORD(wParam) == BN_CLICKED )
        {
            SendMessage(hWnd, (UINT)WM_CLOSE, (WPARAM)0, (LPARAM)0);
        }
        break;
    case WM_DESTROY:
        PostQuitMessage(0);
        break;
    }
    return DefWindowProc(hWnd, Msg, wParam, lParam);
}
