@setlocal enableextensions enabledelayedexpansion
@ECHO OFF

SET F=%~nx1
IF EXIST "%F%.cpp" (
  SET FN="%F%.cpp"
  GOTO start
)
GOTO usage

:start
REM 32 bit
REM SET XTYPE=x86

SET XTYPE=x86_amd64
CALL "%VS140COMNTOOLS%..\..\VC\vcvarsall.bat" %XTYPE%

IF EXIST "%F%.rc" (
  ECHO Compiling resources.....
  Rc "%F%"
  SET VRES="%F%.res"
)
SET WIN_VER=/DWINVER=_WIN32_WINNT_VISTA /D_WIN32_WINNT=_WIN32_WINNT_VISTA

REM cl %FN%  /O1 /Os /GS- /Zc:sizedDealloc- /link TCLib.lib kernel32.lib user32.lib %2 %3

REM cl %FN%  /O1 /Os /GS-  /Gs9999999 /Zc:sizedDealloc- /link /STACK:0x100000,0x100000 TCLib.lib kernel32.lib user32.lib %VRES% %2 %3 %4 %5 %6
REM added /GR- 09/04/2016
REM cl %FN%  /O1 /Os /GS- /GR- /Gs9999999 /Zc:sizedDealloc- /link /STACK:0x100000,0x100000 TCLib.lib kernel32.lib user32.lib %VRES% %2 %3 %4 %5 %6
cl %FN%  /DWIN32_LEAN_AND_MEAN /O1 /Os /Gy /GS- /GR- /Gs9999999 /Zc:sizedDealloc- %WIN_VER% /link /OPT:REF /STACK:0x100000,0x100000 TCLib.lib kernel32.lib user32.lib %VRES% %2 %3 %4 %5 %6


REM cl %FN%  /O1 /Os /GS-  /Zc:sizedDealloc- TCLib.lib kernel32.lib user32.lib %VRES% %2 %3 %4 %5 %6
REM cl %FN%  /O1 /Os /GS- /Gs9999999 /Zc:sizedDealloc- TCLib.lib kernel32.lib user32.lib %VRES% %2 %3 %4 %5 %6


REM Fred -> cl Demo16.cpp Strings.cpp /O1 /Os /GS- /Zc:sizedDealloc- TCLib.lib kernel32.lib
REM cl %FN%  /O1 /Gd /link TCLib.lib kernel32.lib user32.lib %VRES% %2 %3 %4 %5 %6
REM cl %FN%  /O1 /Os /GS- /Zc:sizedDealloc- /link /STACK:0x100000,0x100000 TCLib.lib kernel32.lib user32.lib %VRES% %2 %3 %4 %5 %6
:cleanup
ECHO Finished!
IF EXIST "%F%.obj" del "%F%.obj"
IF EXIST "Strings.obj" del "Strings.obj"

GOTO done

:usage
ECHO **************************************************************
ECHO  Usage:  TCLIB.BAT MainFile  no ext .cpp assumed
ECHO **************************************************************
:done
